#lang scheme
(require vigraplt/vigraplt)

(define myImage (loadimage  
			(build-path vigraplt-path "images/blox.gif")))

(define regionImage (watersheds (ggradient myImage 1.7)))

(show-image regionImage)

(show-image (regionimagetocrackedgeimage regionImage 0.0))

(define region_count (inexact->exact
					(+ (car (image-reduce max regionImage 0))
					    1)))

(define region_sizes  (make-vector region_count))
(define region_colors (make-vector region_count))

(image-for-each-index 
    (lambda (x y band)
	  (let ((region_id (inexact->exact 
                           (image-ref regionImage x y band))) 
             (region_color (inexact->exact 
                              (image-ref myImage x y band))))          
         (begin
		 (vector-set! region_sizes region_id
                (+ 1 (vector-ref region_sizes region_id)))
           (vector-set! region_colors  region_id
                (+ region_color (vector-ref region_colors
                                      region_id))))))
     regionImage)

(define meanColorImage 
    (image-map  
      (lambda (col)
        (let ((color_id (inexact->exact col)))
          (exact->inexact (/ (vector-ref region_colors
                                color_id)
                          (vector-ref region_sizes
                                color_id)))))
      regionImage))

(show-image 
     (regionimagetocrackedgeimage meanColorImage 0.0))

(saveimage 
     (regionimagetocrackedgeimage meanColorImage 0.0)
	(build-path vigraplt-path 
		"images/nice-blox-watersheds.gif"))